Bug 527502 - collector should not sort the generated lists
Summary: collector should not sort the generated lists
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: readahead
Version: 12
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Harald Hoyer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-10-06 17:00 UTC by Raphael Geissert
Modified: 2010-12-04 07:33 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-12-04 07:33:07 UTC
Type: ---


Attachments (Terms of Use)
Preserve he order in which the files are used when writting the files lists (1.70 KB, patch)
2009-10-06 17:00 UTC, Raphael Geissert
no flags Details | Diff

Description Raphael Geissert 2009-10-06 17:00:40 UTC
Created attachment 363857 [details]
Preserve he order in which the files are used when writting the files lists

In the case of SSDs, it is not of much use to sort the files lists by block order. It is more important to readahead the files in the order they will be needed by the programs, so that readahead can be backgrounded.

As a first step, it is necessary to preserve the order in which the files are accessed. The attached (or to be attached, depending on whether bugzilla likes it or not) patch does exactly that.

Comment 1 Harald Hoyer 2009-10-06 17:04:48 UTC
Hmm, does it make sense for SSDs anyway?
Sorting is mainly because of seek time, which is the main gain from readahead.
For SSDs starting initscripts in parallel would make the most sense (like upstart does in newest Ubuntu).

Comment 2 Raphael Geissert 2009-10-07 00:53:24 UTC
Starting init scripts in parallel is helpful in all cases, on Debian we now use a dependencies-based rc which allows us to start scripts in "makefile" mode, i.e. as soon as their dependencies are satisfied. The boot time is reduced in all cases.
In the case of SSDs, using readahead as a backgrounded, low priority, preloading mechanism of the files still reduces the boot time. The trick in the case of SSDs is to preload in the order in which the files will be used. Ideally readahead will have preloaded the files needed by an application before the application requests it to the kernel.
In the case of HDDs the best performance is achieved by preloading by the blocks order[1] with a normal io priority, in the foreground, without having any other application that may request disk access running at the same time.

[1] I do have plans to make readahead work this way, but some major code structure changes are needed. Hope I can count on you to make that happen.

Comment 3 Bug Zapper 2009-11-16 13:19:12 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 4 Bug Zapper 2010-11-04 09:37:21 UTC
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 5 Bug Zapper 2010-12-04 07:33:07 UTC
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.